SystemOrganization addCategory: #'Magritte-RDB-MySQL'!
SystemOrganization addCategory: #'Magritte-RDB-MySQL-Tests'!

TestResource subclass: #MAMysqlTestResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-MySQL-Tests'!

!MAMysqlTestResource methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 18:09'!
databaseInterface

^ MYSQLTester! !

!MAMysqlTestResource methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 21:44'!
setUp

	self databaseInterface execute: 'DROP TABLE IF EXISTS TESTING'.
	self databaseInterface execute: 'CREATE TABLE `testing` (
	  `id` int(11) NOT NULL auto_increment,
	  `bool` char(5) default NULL,
	  `shortbool` char(1) default NULL,
	  `password` char(41) default NULL,
	  `tokens` varchar(255) default NULL,
	  `price` char(10) default NULL,
	  `priceUsd` char(10) default NULL,
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=latin1'  ! !

Object subclass: #MYSQL41
	instanceVariableNames: 'connection spec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-MySQL'!

!MYSQL41 commentStamp: 'kph 9/12/2007 17:43' prior: 0!
Abstract superclass for higher level mysql database accessing.

Subclasses specify the particular database to be accessed!

MYSQL41 subclass: #MYSQL40
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-MySQL'!

!MYSQL40 class methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 18:27'!
writeConverting: value on: stream

	JdmFactory40 instance fieldConverter convertToMysql: value on: stream
	
	! !

!MYSQL41 class methodsFor: 'convenience' stamp: 'kph 9/20/2007 18:51'!
coerceFromDbClass

^ MAMySqlFromDB! !

!MYSQL41 class methodsFor: 'convenience' stamp: 'kph 9/20/2007 18:50'!
coerceToDbClass

^ MAMySqlToDB! !

!MYSQL41 class methodsFor: 'executing' stamp: 'dc 11/7/2005 06:48'!
execute: aSQLString
	^ self new execute: aSQLString! !

!MYSQL41 class methodsFor: 'executing' stamp: 'dc 11/7/2005 06:49'!
execute: aSQLString with: aBlock
	^ self new execute: aSQLString with: aBlock! !

!MYSQL41 class methodsFor: 'convenience' stamp: 'kph 9/20/2007 20:44'!
getDescriptionsOn: aDescribedObject verifying: aBlock 
	"at present verification is performed against raw un-coerced model values"
	^ aDescribedObject class getDescriptionForInsert  select:
		[:description | description label notNil and:
			[aBlock  value: description value: (description accessor read: aDescribedObject)] ]
						! !

!MYSQL41 class methodsFor: 'convenience' stamp: 'dc 11/8/2005 06:34'!
getDictionariesCollectionFrom: aSQLQuery
	^ self new getDictionariesCollectionFrom: aSQLQuery.! !

!MYSQL41 class methodsFor: 'convenience' stamp: 'dc 11/7/2005 20:39'!
getFieldsFromDescriptionOn: aDescribedObject 
	^ self  getFieldsFromDescriptionOn: aDescribedObject
		 verifying: [:description :value | true]! !

!MYSQL41 class methodsFor: 'convenience' stamp: 'dc 11/9/2005 16:55'!
getFieldsFromDescriptionOn: aDescribedObject verifying: aBlock 
	^ self getFieldsFromDescriptionOn: aDescribedObject  verifying: aBlock  separatedBy: ' , '! !

!MYSQL41 class methodsFor: 'convenience' stamp: 'kph 9/20/2007 20:28'!
getFieldsFromDescriptionOn: aDescribedObject verifying: aBlock separatedBy: aString

	| dbWriter |

	dbWriter := self coerceToDbClass client: self.

	^ String  streamContents:
			[:stream | 
				(self getDescriptionsOn: aDescribedObject verifying: aBlock)
					do:	[:description | | table champ |
							table := description pointTo.
							champ := description getFieldName.
							stream nextPutAll: table; nextPut: $.; nextPutAll: champ;
								nextPutAll: '='.
								dbWriter coerce: aDescribedObject description: description on: stream  ]
					separatedBy:[stream  nextPutAll: aString]]! !

!MYSQL41 class methodsFor: 'convenience' stamp: 'dc 11/15/2005 06:14'!
getModelCollectionFrom: aSQLQuery model: aGIModelClass
	^ self new getModelCollectionFrom: aSQLQuery model: aGIModelClass! !

!MYSQL41 class methodsFor: 'convenience' stamp: 'kph 8/12/2007 02:44'!
getModelCollectionFrom: aSQLQuery models: aGIModelClass
	^ self new getModelCollectionFrom: aSQLQuery models: aGIModelClass! !

!MYSQL41 class methodsFor: 'convenience' stamp: 'dc 12/24/2005 16:32'!
getNamesCollectionFrom: aSQLQuery
	^ (self getDictionariesCollectionFrom: aSQLQuery) collect: [:elem | (elem at: 'Id') -> (elem at: 'Name')]! !

!MYSQL41 class methodsFor: 'convenience' stamp: 'kph 9/20/2007 18:26'!
writeConverting: value on: stream

	JdmFactory41 instance fieldConverter convertToMysql: value on: stream
	
	! !

!MYSQL41 methodsFor: 'private' stamp: 'dc 11/7/2005 06:37'!
closeConnection
	connection close.! !

!MYSQL41 methodsFor: 'accessing' stamp: 'kph 9/13/2007 17:58'!
connection
	"Answer the value of connection"

	^ connection! !

!MYSQL41 methodsFor: 'accessing' stamp: 'kph 9/13/2007 17:58'!
connection: anObject
	"Set the value of connection"

	connection := anObject! !

!MYSQL41 methodsFor: 'private' stamp: 'kph 9/13/2007 18:01'!
connectionSpec

 	^ spec ifNil: [ self subclassResponsibility ]! !

!MYSQL41 methodsFor: 'executing' stamp: 'kph 9/13/2007 19:42'!
execute: aSQLString
	self execute: aSQLString with: [:a | ] 
! !

!MYSQL41 methodsFor: 'executing' stamp: 'kph 8/13/2007 23:50'!
execute: aSQLString with: aBlock
	"Execute aSQLString in a new connection and pass the result to aBlock"
	
	self withConnectionDo:
	[ | statement resultSet |
	
		self log dbQuery: aSQLString.
		statement := connection createStatement.
		[ resultSet := statement executeQuery: aSQLString ] 
			on: self mysqlErrorClass do: [ :ex | self log dbError: ex printString. ex pass ].
		self log dbQuery: resultSet printString.	  
		
		aBlock value: resultSet 
		
	] 
	 ! !

!MYSQL41 methodsFor: 'convenience' stamp: 'dc 11/8/2005 06:33'!
getDictionariesCollectionFrom: aSQLQuery
	|  tab |
	self execute: aSQLQuery 
		with: [:res | tab := OrderedCollection new.
				[ res next]
				whileTrue: [tab add: res currentRowAsDictionary]. ].
	
	^ tab! !

!MYSQL41 methodsFor: 'convenience' stamp: 'kph 8/9/2007 03:08'!
getModelCollectionFrom: aSQLQuery model: aGIModelClass
	|  tab |
	self execute: aSQLQuery 
		with: [:res | | row| tab := OrderedCollection new.
				[ (row := res nextAsDictionary) notNil ]
				whileTrue: [ | model |
					model := aGIModelClass new.
					row keysAndValuesDo: [:key :value | model perform: (key asLegalSelector,':') asSymbol 
																with:    value]. 
					tab add: model.]].
	^ tab
 ! !

!MYSQL41 methodsFor: 'convenience' stamp: 'kph 8/12/2007 02:45'!
getModelCollectionFrom: aSQLQuery models: models 
	| tab |
	self
		execute: aSQLQuery
		with: [:res | 
			| row | 
			tab := Dictionary new.
			[(row := res nextAsDictionary) notNil]
				whileTrue: [models
						do: [:modelClass | 
							| model | 
							model := (tab
										at: modelClass
										ifAbsentPut: [OrderedCollection new])
										add: modelClass new.
							row
								keysAndValuesDo: [:key :value | | selector | selector := (key asLegalSelector , ':') asSymbol.
													 (model respondsTo: selector)
												ifTrue: [model perform: selector with: value]]]]].
	^ tab! !

!MYSQL41 methodsFor: 'executing' stamp: 'kph 8/9/2007 00:00'!
mysqlErrorClass

	^ Error! !

!MYSQL41 methodsFor: 'private' stamp: 'kph 8/10/2007 01:06'!
openConnection
 
	Socket initializeNetwork.
	connection := JdmConnection on: self connectionSpec.! !

!MYSQL41 methodsFor: 'accessing' stamp: 'kph 9/13/2007 17:58'!
spec
	"Answer the value of spec"

	^ spec! !

!MYSQL41 methodsFor: 'accessing' stamp: 'kph 9/13/2007 17:58'!
spec: anObject
	"Set the value of spec"

	spec := anObject! !

!MYSQL41 methodsFor: 'executing' stamp: 'kph 8/10/2007 00:43'!
withConnectionDo: aBlock
	self openConnection.
	aBlock ensure: [ self closeConnection ].
	 ! !

MYSQL41 subclass: #MYSQLTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-MySQL-Tests'!

!MYSQLTester commentStamp: 'kph 9/13/2007 18:05' prior: 0!
Database for testing MySql!

!MYSQLTester methodsFor: 'as yet unclassified ' stamp: 'kph 9/20/2007 18:12'!
connectionSpec
 	"set the connection spec to your local test database"
	^ self connectionSpecExample ! !

!MYSQLTester methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 18:12'!
connectionSpecExample
	 "set the connection spec to your local test database"
	^ JdmConnectionSpec new initialize
		user: 'seaside';
		password: 'seaside';
		host: #(127 0 0 1) asByteArray;
		database: 'test';
		port: 3306;
		 yourself
		
 ! !

MACoercingVisitor subclass: #MAMySqlFromDB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-MySQL'!

!MAMySqlFromDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 21:32'!
coerce: anObject description: aDescription to: model

	self coerce: anObject description: aDescription.

	aDescription accessor write: output to: model! !

!MAMySqlFromDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 21:07'!
inputFromString: aDesc

	^ self stringReader read: input readStream description: aDesc! !

!MAMySqlFromDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 21:36'!
visitBooleanDescription: aDesc
	
	 input ifNotNil: [ input := input asLowercase ].
	
 	 super visitBooleanDescription: aDesc! !

!MAMySqlFromDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 21:36'!
visitClassDescription: aDesc

 	output := input ifNil:[ aDesc default yourself ] ifNotNil: [ Smalltalk at: input asSymbol ] 
 
	 ! !

!MAMySqlFromDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 21:37'!
visitDescription: aDesc

 	output := input ifNil:[ aDesc default yourself ] ifNotNil: [ self inputFromString: aDesc ] ! !

!MAMySqlFromDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 21:37'!
visitMagnitudeDescription: aDesc
	
	output := input! !

!MAMySqlFromDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 21:37'!
visitPriceDescription: aDesc
	  input ifNotNil: [ input := input asFixedDecimal: 2].
	 super visitPriceDescription: aDesc! !

MACoercingVisitor subclass: #MAMySqlToDB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-MySQL'!

!MAMySqlToDB commentStamp: 'kph 9/20/2007 19:10' prior: 0!
In writing to the DB we preserve nil.!

!MAMySqlToDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 21:32'!
coerce: anObject description: aDescription on: aStream

	self coerce: anObject description: aDescription.

	convert 
		ifTrue: [ client writeConverting: output on:aStream ]
		ifFalse: [ aStream nextPutAll: output ]
	! !

!MAMySqlToDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 19:09'!
readInput: aDesc

	^ (aDesc accessor read: input) ifNil: [ aDesc default yourself ]! !

!MAMySqlToDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 21:33'!
visitBooleanDescription: aDesc
	"our default boolean mapping is into the strings specified by trueString/falseString
	other options can be provided here according to description properties"
	
	super visitBooleanDescription: aDesc! !

!MAMySqlToDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 21:34'!
visitDescription: aDesc

	convert := true.

	aDesc isWithId ifTrue: [ ^ input key ].

	output := self stringWriter write: ((self readInput: aDesc) ifNil: [ ^ output := nil ]) description: aDesc.
	
 ! !

!MAMySqlToDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 21:34'!
visitMagnitudeDescription: aDesc

	convert := true.
	output := self readInput: aDesc.

 ! !

!MAMySqlToDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 21:39'!
visitPasswordDescription: aDesc 
 
	super visitPasswordDescription: aDesc.
	output := output 
				ifNotNil: 
					[(output size = 41 and: [output beginsWith: '*']) 
						ifFalse: 
							[ convert := false.
							'PASSWORD("' , output asString , '")'. 
							]].
 ! !

!MAMySqlToDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 21:36'!
visitPriceDescription: aDesc
	super visitPriceDescription: aDesc.
 	output := output ifNotNilDo: [ :v | (v asFixedDecimal:2) asString , (aDesc currency ifNil: [ '' ]) ]! !
